#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>

#define ID_PATH	"/sys/class/net/%s/device/read_id"

void usage(char *name)
{
	printf("usage:\n");
	printf("\t%s <canbus>\n", name);
	printf("e.g.\n");
	printf("\t%s can0\n", name);
}

int read_id(char *canbus)
{
	unsigned char buf[128];
	int fd;
	size_t len;
	int id;

	sprintf(buf, ID_PATH, canbus);
	fd = open(buf, O_RDONLY);
	if (fd < 0)
		return -1;

	len = read(fd, buf, sizeof(buf) - 1);
	buf[len] = 0;

	id = strtol(buf, NULL, 16);

	close(fd);
	return id;
}

int main(int argc, char *argv[])
{
	int status;

	if (argc != 2) {
		usage(argv[0]);
		return 0;
	}

	status = read_id(argv[1]);
	if (status >= 0)
		printf("%s id: %x\n", argv[1], status);
	else
		printf("cant get %s id\n", argv[1]);

	return 0;
}
